//////////////////////////////////////////////////////////////////////////////
//
// (C) Copyright Vicente J. Botet Escriba 2008. Distributed under the Boost
// Software License, Version 1.0. (See accompanying file
// LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
//
// See http://www.boost.org/libs/sync for documentation.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __BOOST_SYNC_PROCESS_SYNCHRONIZATION_FAMILY__HPP
#define __BOOST_SYNC_PROCESS_SYNCHRONIZATION_FAMILY__HPP

#include "boost/sync/process/mutex.hpp"
#include "boost/sync/process/recursive_mutex.hpp"
#include "boost/sync/process/upgradable_mutex.hpp"
#include "boost/interprocess/sync/interprocess_condition.hpp"

namespace boost {
namespace sync {


//!Describes interprocess_mutex family to use with Sync framework 
//!based on boost::interprocess synchronization objects.
struct process_synchronization_family
{
   typedef boost::sync::interprocess_mutex              mutex_type;
   typedef boost::sync::interprocess_recursive_mutex    recursive_mutex_type;
   typedef boost::sync::interprocess_mutex	     		timed_mutex_type;
   typedef boost::sync::interprocess_recursive_mutex    recursive_timed_mutex_type;
   typedef boost::sync::interprocess_upgradable_mutex	shared_mutex_type;
   typedef boost::interprocess::interprocess_condition     		condition_type;
};

}
}

#endif
